<script>

  import { getContext, onMount, onDestroy  } from 'svelte';
  import MenuItem                            from './MenuItem.svelte';

  export let menu     = null;
  export let name     = 'menu-item';
  export let type     = 'slider';
  export let label    = 'Menu item';
  export let value    = 0;
  export let index    = -1;
  export let depth    = 0;
  export let path     = [];
  export let classes  = [];
  export let onChange = null;
  export let options  = null;
  export let min      = -Infinity;
  export let max      = +Infinity;
  export let step     = 1;

  const mainContext = getContext('main');

  path = path.slice(0);

  path.push(index);

  if(options instanceof Array) {

    min  = 0;
    max  = options.length - 1;
    step = 1;

  }

  export const reset = function(e) {

    const idx = classes.indexOf('active');

    if(idx !== -1)
      classes.splice(idx, 1);

    classes = classes.slice(0);
  }

  export const onItemWheel = function(e) {
    
    e.preventDefault();

    const prev = value;

    if(e.deltaY < 0) {
      
      value += step;

      if(value > max)
        value = max;
        
    } else if(e.deltaY > 0) {
      
      value -= step;

      if(value < min)
        value = min;

    }

    if(value !== prev)
      window.parent.postMessage(JSON.stringify({action: 'menu_change', data: {name, type, label, value, index, depth, path}}), '*');
  }

  export const onLabelClick = function(e) {
    e.preventDefault();
    mainContext.reset();
  }

  export const getLabel = function(idx) {

    if(options instanceof Array && options.length > idx)
      return options[idx];
    else
      return idx.toString();
  }

  onMount(() => {
    mainContext.registerReset(reset);
  });

  onDestroy(() => {
    mainContext.unregisterReset(reset);
  });

</script>

<style>
  
  .menu-item {
    text-align: center;
    display: flex;
    flex-direction: column;
    height: 35px;
    line-height: 35px;
    width: 0;
  }
  
  .menu-item:hover {
    user-select: none;
  }
  
  .menu-item > .label {
    color: #fff;
    background-color: rgba(0, 0, 0, 0.75);
    height: 25px;
    padding: 0 5px 10px 5px;
    border-left: 1px solid rgba(143, 75, 75, 0.75);
    display: flex;
    flex-direction: row;
    justify-content: flex-start;
    white-space: nowrap;
  }

  .menu-item:nth-child(even) > .label {
    background-color: rgba(0, 0, 0, 0.85);
  }

  .menu-item.active > .label {
    color: rgb(170, 60, 60);
  }

  .label-children {
    display: none;
    flex-direction: column;
  }

  .label-value {
    color: rgb(170, 60, 60);
  }

	.label {
    display: flex;
    flex-direction: column;
		color: #000;
  }

  .label-slider:hover {
    cursor: ns-resize;
  }

  .label-spacer {
    flex-basis: 35px;
  }

  .label-text {
  }

  .label-slider {
    flex-grow: 1;
    text-align: right;
  }

</style>

<div class={`menu-item menu-item-slider ${classes.join(' ')}`} on:wheel={onItemWheel}>

  <div class="label" on:click={onLabelClick}>
      <div class="label-spacer" />
      <div class="label-text">{label}</div>
      <div class="label-slider">&nbsp;&lt;&nbsp;<span class="label-value">{getLabel(value)}</span>&nbsp;&gt</div>
  </div>

</div>
